
#include <Process.au3>
#Include <Array.au3>

#cs

Version 3 is not an improvement of version 2, but actually a disimprovement, because it does not output results in the browser but in a text file, and in the original tab-delimited format.

#ce

Global $fileopenhtml, $glossaryfilecolumns, $glossaryfilelines, $glossaryfileopen, $glossaryfileopendialog, $glossaryfileread, $grabbedtext, $grabbedword, $grabbedwordarray, $htmloutput, $i, $j, $k, $l, $output

MsgBox (0, "GlossLookup version 3 (tab-delimited output)", "GlossLookup looks up glossary terms in the text on the clipboard, and writes the matching glossary lines to a new glossary called output.txt." & @CRLF & @CRLF & "1. I assume your glossary is named 'glossary.txt' and that is in the script's own directory" & @CRLF & "2. I assume that your glossary is UTF8 with so-called BOM (this is the usual form of UTF8 on Windows machines)." & @CRLF & @CRLF & "Shortcuts:" & @CRLF & @CRLF & "Ctrl + C = copy selection to clipboard (normal Windows function)" & @CRLF & "WinKey + C = look up the text on the clipboard" & @CRLF & "WinKey + Q = Exit the program (or right-click its icon in the systray)", 0)

; ==================
; Step 1: define hotkeys
; ==================

HotKeySet("#c", "grabclipandgo")
HotKeySet("#q", "exitty")

; =======================
; Step 2: add glossary to array
; =======================

#cs
$glossaryfileopendialog = FileOpenDialog ("Select glossary", @ScriptDir, "Text files (*.txt)|All files (*.*)") ; uncomment this to be asked for glossary at start of run
#ce

; #cs
$glossaryfileopendialog = @ScriptDir & "\glossary.txt" ; comment this if you uncomment the above
; #ce

$glossaryfileopen = FileOpen ($glossaryfileopendialog, 128) ; 128 means UTF8, 32 means UTF16LE
$glossaryfileread = FileRead ($glossaryfileopen)

$glossaryfilelines = StringSplit ($glossaryfileread, @CRLF, 3)

Global $glossaryfilefirstcolumn[UBound ($glossaryfilelines)]

For $i = 0 to UBound ($glossaryfilelines) - 1
$glossaryfilecolumns = StringSplit ($glossaryfilelines[$i], @TAB, 3)
If UBound ($glossaryfilecolumns) > 1 Then ; i.e. if there are at least 2 columns in the line
$glossaryfilefirstcolumn[$i] = $glossaryfilecolumns[0]
EndIf
Next

; MsgBox (0, "", _ArrayToString($glossaryfilefirstcolumn, " | "), 0) ; If you want to check that the entire glossary was read

; ========================
; Step 3: let script stay resident
; ========================

While 1
Sleep ("100")
WEnd

; =======================================
; Step 3: define functions that respond to hotkeys
; =======================================

Func exitty ()
Exit
EndFunc

Func grabclipandgo()

$grabbedtext = ClipGet()

$output = ""

; ==================
; DO TERM MATCHING
; ==================

For $m = 0 to UBound ($glossaryfilelines) - 1

If StringInStr ($grabbedtext, $glossaryfilefirstcolumn[$m]) Then
$output = $output & $glossaryfilelines[$m] & @CRLF
EndIf

Next

$fileopenhtml = FileOpen ("output.txt", 130) ; 130 means overwrite if exists, 34 would mean the same for UTF16LE

FileWrite ($fileopenhtml, $output)

FileClose ($fileopenhtml)

EndFunc

